Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 74430)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -1278,51 +1550,101 @@
         le = le->Flink;
     }
     
+    num_bits = 0;
+    
     le = tree_writes->Flink;
     while (le != tree_writes) {
         tw = CONTAINING_RECORD(le, tree_write, list_entry);
         
-        if (!tw->overlap) {
-            TRACE("address: %llx, size: %x, overlap = %u\n", tw->address, tw->length, tw->overlap);
-            
-            Status = write_data(Vcb, tw->address, tw->data, TRUE, tw->length, wtc, NULL, NULL);
-            if (!NT_SUCCESS(Status)) {
-                ERR("write_data returned %08x\n", Status);
-                ExFreePool(wtc);
-                return Status;
-            }
-        }
+        if (!tw->overlap)
+            num_bits++;
         
         le = le->Flink;
     }
     
-    if (wtc->stripes.Flink != &wtc->stripes) {
-        // launch writes and wait
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
-            write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-            
-            if (stripe->status != WriteDataStatus_Ignore)
-                IoCallDriver(stripe->device->devobj, stripe->Irp);
-            
-            le = le->Flink;
+    if (num_bits > 0) {
+        write_data_context* wtc;
+        int i;
+        ULONG bit_num = 0;
+        
+        wtc = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_data_context) * num_bits, ALLOC_TAG);
+        if (!wtc) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        KeWaitForSingleObject(&wtc->Event, Executive, KernelMode, FALSE, NULL);
+        le = tree_writes->Flink;
         
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
-            write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
+        while (le != tree_writes) {
+            tw = CONTAINING_RECORD(le, tree_write, list_entry);
             
-            if (stripe->status != WriteDataStatus_Ignore && !NT_SUCCESS(stripe->iosb.Status)) {
-                Status = stripe->iosb.Status;
-                break;
+            if (!tw->overlap) {
+                TRACE("address: %llx, size: %x, overlap = %u\n", tw->address, tw->length, tw->overlap);
+                
+                KeInitializeEvent(&wtc[bit_num].Event, NotificationEvent, FALSE);
+                InitializeListHead(&wtc[bit_num].stripes);
+                wtc[bit_num].tree = TRUE;
+                wtc[bit_num].stripes_left = 0;
+                wtc[bit_num].parity1 = wtc[bit_num].parity2 = wtc[bit_num].scratch = NULL;
+                wtc[bit_num].mdl = wtc[bit_num].parity1_mdl = wtc[bit_num].parity2_mdl = NULL;
+                
+                Status = write_data(Vcb, tw->address, tw->data, tw->length, &wtc[bit_num], NULL, NULL, FALSE, 0);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("write_data returned %08x\n", Status);
+                    
+                    for (i = 0; i < num_bits; i++) {
+                        free_write_data_stripes(&wtc[i]);
+                    }
+                    ExFreePool(wtc);
+                    
+                    return Status;
+                }
+                
+                bit_num++;
             }
             
             le = le->Flink;
         }
         
-        free_write_data_stripes(wtc);
+        for (i = 0; i < num_bits; i++) {
+            if (wtc[i].stripes.Flink != &wtc[i].stripes) {
+                // launch writes and wait
+                le = wtc[i].stripes.Flink;
+                while (le != &wtc[i].stripes) {
+                    write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
+                    
+                    if (stripe->status != WriteDataStatus_Ignore)
+                        IoCallDriver(stripe->device->devobj, stripe->Irp);
+                    
+                    le = le->Flink;
+                }
+            }
+        }
+
+        for (i = 0; i < num_bits; i++) {
+            if (wtc[i].stripes.Flink != &wtc[i].stripes) {
+                KeWaitForSingleObject(&wtc[i].Event, Executive, KernelMode, FALSE, NULL);
+            }
+        }
+
+        for (i = 0; i < num_bits; i++) {
+            le = wtc[i].stripes.Flink;
+            while (le != &wtc[i].stripes) {
+                write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
+                
+                if (stripe->status != WriteDataStatus_Ignore && !NT_SUCCESS(stripe->iosb.Status)) {
+                    Status = stripe->iosb.Status;
+                    log_device_error(Vcb, stripe->device, BTRFS_DEV_STAT_WRITE_ERRORS);
+                    break;
+                }
+                
+                le = le->Flink;
+            }
+                
+            free_write_data_stripes(&wtc[i]);
+        }
+        
+        ExFreePool(wtc);
     }
     
     le = tree_writes->Flink;
@@ -1332,10 +1654,9 @@
         if (tw->overlap) {
             TRACE("address: %llx, size: %x, overlap = %u\n", tw->address, tw->length, tw->overlap);
             
-            Status = write_data_complete(Vcb, tw->address, tw->data, tw->length, Irp, NULL);
+            Status = write_data_complete(Vcb, tw->address, tw->data, tw->length, Irp, NULL, FALSE, 0);
             if (!NT_SUCCESS(Status)) {
                 ERR("write_data_complete returned %08x\n", Status);
-                ExFreePool(wtc);
                 return Status;
             }
         }
@@ -1376,7 +1697,7 @@
                 
                 if (!t->has_new_address) {
                     ERR("error - tried to write tree with no new address\n");
-                    int3;
+                    return STATUS_INTERNAL_ERROR;
                 }
                 
                 le2 = t->itemlist.Flink;
@@ -1472,6 +1793,9 @@
 
         if (t->write) {
 #ifdef DEBUG_PARANOID
+            BOOL first = TRUE;
+            KEY lastkey;
+            
             le2 = t->itemlist.Flink;
             while (le2 != &t->itemlist) {
                 tree_data* td = CONTAINING_RECORD(le2, tree_data, list_entry);
@@ -1478,6 +1802,19 @@
                 if (!td->ignore) {
                     num_items++;
                     
+                    if (!first) {
+                        if (keycmp(td->key, lastkey) == 0) {
+                            ERR("(%llx,%x,%llx): duplicate key\n", td->key.obj_id, td->key.obj_type, td->key.offset);
+                            crash = TRUE;
+                        } else if (keycmp(td->key, lastkey) == -1) {
+                            ERR("(%llx,%x,%llx): key out of order\n", td->key.obj_id, td->key.obj_type, td->key.offset);
+                            crash = TRUE;
+                        }
+                    } else
+                        first = FALSE;
+                    
+                    lastkey = td->key;
+                    
                     if (t->header.level == 0)
                         size += td->size;
                 }
@@ -1509,6 +1846,11 @@
                 crash = TRUE;
             }
             
+            if (t->header.level > 0 && t->header.num_items == 1) {
+                ERR("tree %llx, level %x: internal tree has only one item\n", t->root->id, t->header.level);
+                crash = TRUE;
+            }
+            
             if (crash) {
                 ERR("tree %p\n", t);
                 le2 = t->itemlist.Flink;
@@ -1639,6 +1981,9 @@
         le = RemoveHeadList(&tree_writes);
         tw = CONTAINING_RECORD(le, tree_write, list_entry);
         
+        if (tw->data)
+            ExFreePool(tw->data);
+        
         ExFreePool(tw);
     }
     
@@ -1714,42 +2059,130 @@
     sb->num_devices = Vcb->superblock.num_devices;
 }
 
-static NTSTATUS STDCALL write_superblock(device_extension* Vcb, device* device) {
+typedef struct {
+    void* context;
+    UINT8* buf;
+    PMDL mdl;
+    device* device;
     NTSTATUS Status;
+    PIRP Irp;
+    LIST_ENTRY list_entry;
+} write_superblocks_stripe;
+
+typedef struct _write_superblocks_context {
+    KEVENT Event;
+    LIST_ENTRY stripes;
+    LONG left;
+} write_superblocks_context;
+
+static NTSTATUS STDCALL write_superblock_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+    write_superblocks_stripe* stripe = conptr;
+    write_superblocks_context* context = stripe->context;
+    
+    UNUSED(DeviceObject);
+    
+    stripe->Status = Irp->IoStatus.Status;
+    
+    if (InterlockedDecrement(&context->left) == 0)
+        KeSetEvent(&context->Event, 0, FALSE);
+    
+    return STATUS_MORE_PROCESSING_REQUIRED;
+}
+
+static NTSTATUS STDCALL write_superblock(device_extension* Vcb, device* device, write_superblocks_context* context) {
     unsigned int i = 0;
-    UINT32 crc32;
-#ifdef __REACTOS__
-    Status = STATUS_INTERNAL_ERROR;
-#endif
     
-    RtlCopyMemory(&Vcb->superblock.dev_item, &device->devitem, sizeof(DEV_ITEM));
-    
     // All the documentation says that the Linux driver only writes one superblock
     // if it thinks a disk is an SSD, but this doesn't seem to be the case!
     
-    while (superblock_addrs[i] > 0 && device->length >= superblock_addrs[i] + sizeof(superblock)) {
-        TRACE("writing superblock %u\n", i);
+    while (superblock_addrs[i] > 0 && device->devitem.num_bytes >= superblock_addrs[i] + sizeof(superblock)) {
+        ULONG sblen = sector_align(sizeof(superblock), Vcb->superblock.sector_size);
+        superblock* sb;
+        UINT32 crc32;
+        write_superblocks_stripe* stripe;
+        PIO_STACK_LOCATION IrpSp;
         
-        Vcb->superblock.sb_phys_addr = superblock_addrs[i];
+        sb = ExAllocatePoolWithTag(NonPagedPool, sblen, ALLOC_TAG);
+        if (!sb) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
         
-        crc32 = calc_crc32c(0xffffffff, (UINT8*)&Vcb->superblock.uuid, (ULONG)sizeof(superblock) - sizeof(Vcb->superblock.checksum));
-        crc32 = ~crc32;
-        TRACE("crc32 is %08x\n", crc32);
-        RtlCopyMemory(&Vcb->superblock.checksum, &crc32, sizeof(UINT32));
+        RtlCopyMemory(sb, &Vcb->superblock, sizeof(superblock));
         
-        Status = write_data_phys(device->devobj, superblock_addrs[i], &Vcb->superblock, sizeof(superblock));
+        if (sblen > sizeof(superblock))
+            RtlZeroMemory((UINT8*)sb + sizeof(superblock), sblen - sizeof(superblock));
         
-        if (!NT_SUCCESS(Status))
-            break;
+        RtlCopyMemory(&sb->dev_item, &device->devitem, sizeof(DEV_ITEM));
+        sb->sb_phys_addr = superblock_addrs[i];
         
+        crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
+        RtlCopyMemory(&sb->checksum, &crc32, sizeof(UINT32));
+        
+        stripe = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_superblocks_stripe), ALLOC_TAG);
+        if (!sb) {
+            ERR("out of memory\n");
+            ExFreePool(sb);
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        stripe->buf = (UINT8*)sb;
+        
+        stripe->Irp = IoAllocateIrp(device->devobj->StackSize, FALSE);
+        if (!stripe->Irp) {
+            ERR("IoAllocateIrp failed\n");
+            ExFreePool(stripe);
+            ExFreePool(sb);
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        IrpSp = IoGetNextIrpStackLocation(stripe->Irp);
+        IrpSp->MajorFunction = IRP_MJ_WRITE;
+        
+        if (i == 0)
+            IrpSp->Flags |= SL_WRITE_THROUGH;
+        
+        if (device->devobj->Flags & DO_BUFFERED_IO) {
+            stripe->Irp->AssociatedIrp.SystemBuffer = sb;
+            stripe->mdl = NULL;
+
+            stripe->Irp->Flags = IRP_BUFFERED_IO;
+        } else if (device->devobj->Flags & DO_DIRECT_IO) {
+            stripe->mdl = IoAllocateMdl(sb, sblen, FALSE, FALSE, NULL);
+            if (!stripe->mdl) {
+                ERR("IoAllocateMdl failed\n");
+                IoFreeIrp(stripe->Irp);
+                ExFreePool(stripe);
+                ExFreePool(sb);
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+            
+            stripe->Irp->MdlAddress = stripe->mdl;
+            
+            MmBuildMdlForNonPagedPool(stripe->mdl);
+        } else {
+            stripe->Irp->UserBuffer = sb;
+            stripe->mdl = NULL;
+        }
+
+        IrpSp->Parameters.Write.Length = sblen;
+        IrpSp->Parameters.Write.ByteOffset.QuadPart = superblock_addrs[i];
+
+        IoSetCompletionRoutine(stripe->Irp, write_superblock_completion, stripe, TRUE, TRUE, TRUE);
+        
+        stripe->context = context;
+        stripe->device = device;
+        InsertTailList(&context->stripes, &stripe->list_entry);
+        
+        context->left++;
+        
         i++;
     }
     
-    if (i == 0) {
+    if (i == 0)
         ERR("no superblocks written!\n");
-    }
 
-    return Status;
+    return STATUS_SUCCESS;
 }
 
 static NTSTATUS write_superblocks(device_extension* Vcb, PIRP Irp) {
@@ -1756,6 +2189,7 @@
     UINT64 i;
     NTSTATUS Status;
     LIST_ENTRY* le;
+    write_superblocks_context context;
     
     TRACE("(%p)\n", Vcb);
     
@@ -1783,15 +2217,19 @@
     
     update_backup_superblock(Vcb, &Vcb->superblock.backup[BTRFS_NUM_BACKUP_ROOTS - 1], Irp);
     
+    KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
+    InitializeListHead(&context.stripes);
+    context.left = 0;
+    
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
         
         if (dev->devobj && !dev->readonly) {
-            Status = write_superblock(Vcb, dev);
+            Status = write_superblock(Vcb, dev, &context);
             if (!NT_SUCCESS(Status)) {
                 ERR("write_superblock returned %08x\n", Status);
-                return Status;
+                goto end;
             }
         }
         
@@ -1798,7 +2236,60 @@
         le = le->Flink;
     }
     
-    return STATUS_SUCCESS;
+    if (IsListEmpty(&context.stripes)) {
+        ERR("error - not writing any superblocks\n");
+        Status = STATUS_INTERNAL_ERROR;
+        goto end;
+    }
+    
+    le = context.stripes.Flink;
+    while (le != &context.stripes) {
+        write_superblocks_stripe* stripe = CONTAINING_RECORD(le, write_superblocks_stripe, list_entry);
+        
+        IoCallDriver(stripe->device->devobj, stripe->Irp);
+        
+        le = le->Flink;
+    }
+    
+    KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
+    
+    le = context.stripes.Flink;
+    while (le != &context.stripes) {
+        write_superblocks_stripe* stripe = CONTAINING_RECORD(le, write_superblocks_stripe, list_entry);
+        
+        if (!NT_SUCCESS(stripe->Status)) {
+            ERR("device %llx returned %08x\n", stripe->device->devitem.dev_id, stripe->Status);
+            log_device_error(Vcb, stripe->device, BTRFS_DEV_STAT_WRITE_ERRORS);
+            Status = stripe->Status;
+            goto end;
+        }
+        
+        le = le->Flink;
+    }
+    
+    Status = STATUS_SUCCESS;
+    
+end:
+    while (!IsListEmpty(&context.stripes)) {
+        write_superblocks_stripe* stripe = CONTAINING_RECORD(RemoveHeadList(&context.stripes), write_superblocks_stripe, list_entry);
+
+        if (stripe->mdl) {
+            if (stripe->mdl->MdlFlags & MDL_PAGES_LOCKED)
+                MmUnlockPages(stripe->mdl);
+
+            IoFreeMdl(stripe->mdl);
+        }
+        
+        if (stripe->Irp)
+            IoFreeIrp(stripe->Irp);
+        
+        if (stripe->buf)
+            ExFreePool(stripe->buf);
+
+        ExFreePool(stripe);
+    }
+
+    return Status;
 }
 
 static NTSTATUS flush_changed_extent(device_extension* Vcb, chunk* c, changed_extent* ce, PIRP Irp, LIST_ENTRY* rollback) {
@@ -1823,7 +2314,6 @@
     le = ce->refs.Flink;
     while (le != &ce->refs) {
         changed_extent_ref* cer = CONTAINING_RECORD(le, changed_extent_ref, list_entry);
-        LIST_ENTRY* le3 = le->Flink;
         UINT64 old_count = 0;
         
         if (cer->type == TYPE_EXTENT_DATA_REF) {
@@ -1833,9 +2323,6 @@
                 
                 if (cer2->type == TYPE_EXTENT_DATA_REF && cer2->edr.root == cer->edr.root && cer2->edr.objid == cer->edr.objid && cer2->edr.offset == cer->edr.offset) {
                     old_count = cer2->edr.count;
-                    
-                    RemoveEntryList(&cer2->list_entry);
-                    ExFreePool(cer2);
                     break;
                 }
                 
@@ -1845,15 +2332,60 @@
             old_size = ce->old_count > 0 ? ce->old_size : ce->size;
             
             if (cer->edr.count > old_count) {
-                Status = increase_extent_refcount_data(Vcb, ce->address, old_size, cer->edr.root, cer->edr.objid, cer->edr.offset, cer->edr.count - old_count, Irp, rollback);
+                Status = increase_extent_refcount_data(Vcb, ce->address, old_size, cer->edr.root, cer->edr.objid, cer->edr.offset, cer->edr.count - old_count, Irp);
                             
                 if (!NT_SUCCESS(Status)) {
                     ERR("increase_extent_refcount_data returned %08x\n", Status);
                     return Status;
                 }
-            } else if (cer->edr.count < old_count) {
+            }
+        } else if (cer->type == TYPE_SHARED_DATA_REF) {
+            le2 = ce->old_refs.Flink;
+            while (le2 != &ce->old_refs) {
+                changed_extent_ref* cer2 = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
+                
+                if (cer2->type == TYPE_SHARED_DATA_REF && cer2->sdr.offset == cer->sdr.offset) {
+//                     old_count = cer2->edr.count;
+                    
+                    RemoveEntryList(&cer2->list_entry);
+                    ExFreePool(cer2);
+                    break;
+                }
+                
+                le2 = le2->Flink;
+            }            
+        }
+        
+        le = le->Flink;
+    }
+    
+    le = ce->refs.Flink;
+    while (le != &ce->refs) {
+        changed_extent_ref* cer = CONTAINING_RECORD(le, changed_extent_ref, list_entry);
+        LIST_ENTRY* le3 = le->Flink;
+        UINT64 old_count = 0;
+        
+        if (cer->type == TYPE_EXTENT_DATA_REF) {
+            le2 = ce->old_refs.Flink;
+            while (le2 != &ce->old_refs) {
+                changed_extent_ref* cer2 = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
+                
+                if (cer2->type == TYPE_EXTENT_DATA_REF && cer2->edr.root == cer->edr.root && cer2->edr.objid == cer->edr.objid && cer2->edr.offset == cer->edr.offset) {
+                    old_count = cer2->edr.count;
+                    
+                    RemoveEntryList(&cer2->list_entry);
+                    ExFreePool(cer2);
+                    break;
+                }
+                
+                le2 = le2->Flink;
+            }
+            
+            old_size = ce->old_count > 0 ? ce->old_size : ce->size;
+            
+            if (cer->edr.count < old_count) {
                 Status = decrease_extent_refcount_data(Vcb, ce->address, old_size, cer->edr.root, cer->edr.objid, cer->edr.offset,
-                                                       old_count - cer->edr.count, ce->superseded, Irp, rollback);
+                                                       old_count - cer->edr.count, ce->superseded, Irp);
                 
                 if (!NT_SUCCESS(Status)) {
                     ERR("decrease_extent_refcount_data returned %08x\n", Status);
@@ -1893,28 +2425,18 @@
                 } else
                     data = NULL;
                 
-                if (!insert_tree_item(Vcb, Vcb->extent_root, ce->address, TYPE_EXTENT_ITEM, ce->size, data, tp.item->size, NULL, Irp, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+                Status = insert_tree_item(Vcb, Vcb->extent_root, ce->address, TYPE_EXTENT_ITEM, ce->size, data, tp.item->size, NULL, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
                 
-                delete_tree_item(Vcb, &tp, rollback);
+                Status = delete_tree_item(Vcb, &tp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return Status;
+                }
             }
-        } else if (cer->type == TYPE_SHARED_DATA_REF) {
-            le2 = ce->old_refs.Flink;
-            while (le2 != &ce->old_refs) {
-                changed_extent_ref* cer2 = CONTAINING_RECORD(le2, changed_extent_ref, list_entry);
-                
-                if (cer2->type == TYPE_SHARED_DATA_REF && cer2->sdr.offset == cer->sdr.offset) {
-//                     old_count = cer2->edr.count;
-                    
-                    RemoveEntryList(&cer2->list_entry);
-                    ExFreePool(cer2);
-                    break;
-                }
-                
-                le2 = le2->Flink;
-            }            
         }
        
         RemoveEntryList(&cer->list_entry);
@@ -1930,7 +2452,7 @@
     
 end:
     if (ce->count == 0 && !ce->superseded) {
-        decrease_chunk_usage(c, ce->size);
+        c->used -= ce->size;
         space_list_add(Vcb, c, TRUE, ce->address, ce->size, rollback);
     }
 
@@ -1940,7 +2462,7 @@
     return STATUS_SUCCESS;
 }
 
-void add_checksum_entry(device_extension* Vcb, UINT64 address, ULONG length, UINT32* csum, PIRP Irp, LIST_ENTRY* rollback) {
+void add_checksum_entry(device_extension* Vcb, UINT64 address, ULONG length, UINT32* csum, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp, next_tp;
     UINT32* data;
@@ -1976,9 +2498,10 @@
                 
                 RtlCopyMemory(checksums, data, il * sizeof(UINT32));
                 
-                if (!insert_tree_item(Vcb, Vcb->checksum_root, EXTENT_CSUM_ID, TYPE_EXTENT_CSUM, off, checksums,
-                                        il * sizeof(UINT32), NULL, Irp, rollback)) {
-                    ERR("insert_tree_item failed\n");
+                Status = insert_tree_item(Vcb, Vcb->checksum_root, EXTENT_CSUM_ID, TYPE_EXTENT_CSUM, off, checksums,
+                                          il * sizeof(UINT32), NULL, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
                     ExFreePool(checksums);
                     return;
                 }
@@ -2064,7 +2587,11 @@
                     RtlClearBits(&bmp, (tp.item->key.offset - startaddr) / Vcb->superblock.sector_size, itemlen / sizeof(UINT32));
                 }
                 
-                delete_tree_item(Vcb, &tp, rollback);
+                Status = delete_tree_item(Vcb, &tp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return;
+                }
             }
             
             if (find_next_item(Vcb, &tp, &next_tp, FALSE, Irp)) {
@@ -2104,8 +2631,9 @@
                 
                 off = startaddr + UInt32x32To64(index, Vcb->superblock.sector_size);
                 
-                if (!insert_tree_item(Vcb, Vcb->checksum_root, EXTENT_CSUM_ID, TYPE_EXTENT_CSUM, off, data, sizeof(UINT32) * rl, NULL, Irp, rollback)) {
-                    ERR("insert_tree_item failed\n");
+                Status = insert_tree_item(Vcb, Vcb->checksum_root, EXTENT_CSUM_ID, TYPE_EXTENT_CSUM, off, data, sizeof(UINT32) * rl, NULL, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
                     ExFreePool(data);
                     ExFreePool(bmparr);
                     ExFreePool(checksums);
@@ -2141,6 +2669,16 @@
         
         ExAcquireResourceExclusiveLite(&c->lock, TRUE);
         
+        if (!c->cache_loaded && (!IsListEmpty(&c->changed_extents) || c->used != c->oldused)) {
+            Status = load_cache_chunk(Vcb, c, NULL);
+            
+            if (!NT_SUCCESS(Status)) {
+                ERR("load_cache_chunk returned %08x\n", Status);
+                ExReleaseResourceLite(&c->lock);
+                goto end;
+            }
+        }
+        
         le2 = c->changed_extents.Flink;
         while (le2 != &c->changed_extents) {
             LIST_ENTRY* le3 = le2->Flink;
@@ -2159,7 +2697,7 @@
         // This is usually done by update_chunks, but we have to check again in case any new chunks
         // have been allocated since.
         if (c->created) {
-            Status = create_chunk(Vcb, c, Irp, rollback);
+            Status = create_chunk(Vcb, c, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("create_chunk returned %08x\n", Status);
                 ExReleaseResourceLite(&c->lock);
@@ -2166,6 +2704,26 @@
                 goto end;
             }
         }
+        
+        if (c->old_cache) {
+            if (c->old_cache->dirty) {
+                LIST_ENTRY batchlist;
+                
+                InitializeListHead(&batchlist);
+                
+                Status = flush_fcb(c->old_cache, FALSE, &batchlist, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("flush_fcb returned %08x\n", Status);
+                    ExReleaseResourceLite(&c->lock);
+                    goto end;
+                }
+                
+                commit_batch_list(Vcb, &batchlist, Irp);
+            }
+            
+            free_fcb(c->old_cache);
+            c->old_cache = NULL;
+        }
 
         if (c->used != c->oldused) {
             searchkey.obj_id = c->offset;
@@ -2181,7 +2739,6 @@
             
             if (keycmp(searchkey, tp.item->key)) {
                 ERR("could not find (%llx,%x,%llx) in extent_root\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
-                int3;
                 Status = STATUS_INTERNAL_ERROR;
                 ExReleaseResourceLite(&c->lock);
                 goto end;
@@ -2207,12 +2764,18 @@
             
             TRACE("adjusting usage of chunk %llx to %llx\n", c->offset, c->used);
             
-            delete_tree_item(Vcb, &tp, rollback);
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                ExFreePool(bgi);
+                ExReleaseResourceLite(&c->lock);
+                goto end;
+            }
             
-            if (!insert_tree_item(Vcb, Vcb->extent_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, bgi, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
+            Status = insert_tree_item(Vcb, Vcb->extent_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, bgi, tp.item->size, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
                 ExFreePool(bgi);
-                Status = STATUS_INTERNAL_ERROR;
                 ExReleaseResourceLite(&c->lock);
                 goto end;
             }
@@ -2310,7 +2873,10 @@
     nt->new_address = 0;
     nt->has_new_address = FALSE;
     nt->updated_extents = FALSE;
+    nt->uniqueness_determined = TRUE;
+    nt->is_unique = TRUE;
     nt->list_entry_hash.Flink = NULL;
+    nt->buf = NULL;
     InitializeListHead(&nt->itemlist);
     
 //     ExInitializeResourceLite(&nt->nonpaged->load_tree_lock);
@@ -2390,6 +2956,27 @@
             
             le = le->Flink;
         }
+    } else {
+        LIST_ENTRY* le = nt->itemlist.Flink;
+        
+        while (le != &nt->itemlist) {
+            tree_data* td2 = CONTAINING_RECORD(le, tree_data, list_entry);
+            
+            if (!td2->inserted && td2->data) {
+                UINT8* data = ExAllocatePoolWithTag(PagedPool, td2->size, ALLOC_TAG);
+                
+                if (!data) {
+                    ERR("out of memory\n");
+                    return STATUS_INSUFFICIENT_RESOURCES;
+                }
+                
+                RtlCopyMemory(data, td2->data, td2->size);
+                td2->data = data;
+                td2->inserted = TRUE;
+            }
+            
+            le = le->Flink;
+        }
     }
     
     if (nt->parent) {
@@ -2444,7 +3031,10 @@
     pt->updated_extents = FALSE;
 //     pt->nonpaged = ExAllocatePoolWithTag(NonPagedPool, sizeof(tree_nonpaged), ALLOC_TAG);
     pt->size = pt->header.num_items * sizeof(internal_node);
+    pt->uniqueness_determined = TRUE;
+    pt->is_unique = TRUE;
     pt->list_entry_hash.Flink = NULL;
+    pt->buf = NULL;
     InitializeListHead(&pt->itemlist);
     
 //     ExInitializeResourceLite(&pt->nonpaged->load_tree_lock);
@@ -2550,7 +3140,7 @@
                 ERR("(%llx,%x,%llx) in tree %llx is too large (%x > %x)\n",
                     td->key.obj_id, td->key.obj_type, td->key.offset, t->root->id,
                     ds, Vcb->superblock.node_size - sizeof(tree_header));
-                int3;
+                return STATUS_INTERNAL_ERROR;
             }
             
             // FIXME - move back if previous item was deleted item with same key
